diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/wifi-txop-test.cc ns-3.44/src/wifi/test/wifi-txop-test.cc
--- ns-3.43/src/wifi/test/wifi-txop-test.cc	2024-10-09 16:41:10.140657000 -0700
+++ ns-3.44/src/wifi/test/wifi-txop-test.cc	2025-03-09 16:55:49.815372700 -0700
@@ -877,46 +1036,46 @@
     NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "CTS in response to the first RTS frame sent too late");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[14].header.IsCts(), true, "Expected a CTS");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[14].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[16].header.IsCts(), true, "Expected a CTS");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[16].header.GetAddr1(),
                           apDev->GetMac()->GetAddress(),
                           "Expected a CTS frame sent to the AP");
     NS_TEST_EXPECT_MSG_EQ(
-        m_txPsdus[14].header.GetDuration(),
-        RoundDurationId(m_txPsdus[13].header.GetDuration() - sifs - m_txPsdus[14].txDuration),
+        m_txPsdus[16].header.GetDuration(),
+        RoundDurationId(m_txPsdus[15].header.GetDuration() - sifs - m_txPsdus[16].txDuration),
         "Duration/ID of the CTS frame must be derived from that of the RTS frame");
 
     // the AP sends a frame to STA1
-    tEnd = m_txPsdus[14].txStart + m_txPsdus[14].txDuration;
-    tStart = m_txPsdus[15].txStart;
+    tEnd = m_txPsdus[16].txStart + m_txPsdus[16].txDuration;
+    tStart = m_txPsdus[17].txStart;
 
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "First QoS data frame sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "First QoS data frame sent too late");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[15].header.IsQosData(), true, "Expected a QoS data frame");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[15].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[17].header.IsQosData(), true, "Expected a QoS data frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[17].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(0))->GetMac()->GetAddress(),
                           "Expected a frame sent by the AP to the first station");
     if (m_lengthBasedRtsCtsThresh)
     {
-        NS_TEST_EXPECT_MSG_GT(m_txPsdus[15].size,
+        NS_TEST_EXPECT_MSG_GT(m_txPsdus[17].size,
                               rtsCtsThreshold,
                               "PSDU size expected to exceed length based RTS/CTS threshold");
     }
     else
     {
-        NS_TEST_EXPECT_MSG_GT(m_txPsdus[15].txDuration,
+        NS_TEST_EXPECT_MSG_GT(m_txPsdus[17].txDuration,
                               rtsCtsTxDurationThresh,
                               "PSDU duration expected to exceed duration based RTS/CTS threshold");
     }
     NS_TEST_EXPECT_MSG_EQ(
-        m_txPsdus[15].header.GetDuration(),
-        RoundDurationId(m_apTxopLimit - (m_txPsdus[15].txStart - txopStart) -
-                        m_txPsdus[15].txDuration),
+        m_txPsdus[17].header.GetDuration(),
+        RoundDurationId(m_apTxopLimit - (m_txPsdus[17].txStart - txopStart) -
+                        m_txPsdus[17].txDuration),
         "Duration/ID of the first QoS data frame does not cover the remaining TXOP");
 
     // a Normal/Block Ack is then sent by STA1
-    tEnd = m_txPsdus[15].txStart + m_txPsdus[15].txDuration;
-    tStart = m_txPsdus[16].txStart;
+    tEnd = m_txPsdus[17].txStart + m_txPsdus[17].txDuration;
+    tStart = m_txPsdus[18].txStart;
 
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs,
                           tStart,
@@ -925,18 +1084,18 @@
                           tEnd + sifs + tolerance,
                           ack << " in response to the first QoS data frame sent too late");
     NS_TEST_EXPECT_MSG_EQ(
-        (m_nonHt ? m_txPsdus[16].header.IsAck() : m_txPsdus[16].header.IsBlockAck()),
+        (m_nonHt ? m_txPsdus[18].header.IsAck() : m_txPsdus[18].header.IsBlockAck()),
         true,
         "Expected a " << ack);
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[16].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[18].header.GetAddr1(),
                           apDev->GetMac()->GetAddress(),
                           "Expected a " << ack << " sent to the AP");
     NS_TEST_EXPECT_MSG_EQ(
-        m_txPsdus[16].header.GetDuration(),
-        RoundDurationId(m_txPsdus[15].header.GetDuration() - sifs - m_txPsdus[16].txDuration),
+        m_txPsdus[18].header.GetDuration(),
+        RoundDurationId(m_txPsdus[17].header.GetDuration() - sifs - m_txPsdus[18].txDuration),
         "Duration/ID of the " << ack << " must be derived from that of the previous frame");
 
-    std::size_t idx = 16;
+    std::size_t idx = 18;
 
     if (!m_singleRtsPerTxop)
     {
@@ -1142,17 +1301,17 @@
     }
 
     // Expected received packets:
-    // - 3 DL packets (without RTS/CTS)
+    // - 4 DL packets (without RTS/CTS) if non-HT, 5 DL packets (without RTS/CTS) if HE
     // - 1 UL packet
     // - 3 DL packets (with RTS/CTS) if non-HT, 6 DL packets (with RTS/CTS) if HE
-    NS_TEST_EXPECT_MSG_EQ(m_received, (m_nonHt ? 7 : 10), "Unexpected number of packets received");
+    NS_TEST_EXPECT_MSG_EQ(m_received, (m_nonHt ? 8 : 12), "Unexpected number of packets received");
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief wifi TXOP Test Suite
+ * @brief wifi TXOP Test Suite
  */
 class WifiTxopTestSuite : public TestSuite
 {
@@ -1168,17 +1327,20 @@
         AddTestCase(new WifiTxopTest({.nonHt = nonHt,
                                       .pifsRecovery = true,
                                       .singleRtsPerTxop = false,
-                                      .lengthBasedRtsCtsThresh = false}),
+                                      .lengthBasedRtsCtsThresh = false,
+                                      .protectedIfResponded = true}),
                     TestCase::Duration::QUICK);
         AddTestCase(new WifiTxopTest({.nonHt = nonHt,
                                       .pifsRecovery = false,
                                       .singleRtsPerTxop = true,
-                                      .lengthBasedRtsCtsThresh = false}),
+                                      .lengthBasedRtsCtsThresh = false,
+                                      .protectedIfResponded = false}),
                     TestCase::Duration::QUICK);
         AddTestCase(new WifiTxopTest({.nonHt = nonHt,
                                       .pifsRecovery = true,
                                       .singleRtsPerTxop = true,
-                                      .lengthBasedRtsCtsThresh = true}),
+                                      .lengthBasedRtsCtsThresh = true,
+                                      .protectedIfResponded = true}),
                     TestCase::Duration::QUICK);
     }
 }
